<template>
  <label class="Duration"
    ><span class="Duration__Label">{{ t('component.duration.label') }}</span>
    <PSkeleton v-if="loading"></PSkeleton>
    <template v-if="!loading">
      <div v-if="edit" class="p-inputgroup">
        <PInputNumber
          v-model="localDurationMin"
          class="Duration__Min Duration__Min--input"
          :placeholder="t('resource.task.durationMin')"
          :title="t('resource.task.durationMin')"
          mode="decimal"
          :min-fraction-digits="0"
          :max-fraction-digits="2"
        />
        <span class="p-inputgroup-addon">h</span>
      </div>
      <span v-else class="Duration__Min">{{ display(props.durationMin) }}</span>
      <span class="Duration__Separator">-</span>
      <div v-if="edit" class="p-inputgroup">
        <PInputNumber
          v-model="localDurationMax"
          class="Duration__Max Duration__Max--input"
          :placeholder="t('resource.task.durationMax')"
          :title="t('resource.task.durationMax')"
          mode="decimal"
          :min-fraction-digits="0"
          :max-fraction-digits="2"
        />
        <span class="p-inputgroup-addon">h</span>
      </div>
      <span v-else class="Duration__Max">{{ display(props.durationMax) }}</span>
      <ErrorWrapper :errors="errors.durationMin" />
      <ErrorWrapper :errors="errors.durationMax" />
    </template>
  </label>
</template>

<script lang="ts" setup>
import { useI18n } from 'vue-i18n'
import { FieldErrors, FieldName } from '@/components/form/validation'
import { computed } from 'vue'
import moment from 'moment-timezone'
import ErrorWrapper from '@/components/form/ErrorWrapper.vue'

const { t } = useI18n()
const props = withDefaults(
  defineProps<{
    durationMin: number
    durationMax: number
    edit: boolean
    loading: boolean
    errors: Record<FieldName, FieldErrors>
  }>(),
  {
    edit: false,
    loading: false,
    durationMin: 0,
    durationMax: 0,
    errors: () => ({}),
  }
)

function display(durationInMinutes: number) {
  return moment.duration(durationInMinutes, 'minutes').humanize()
}

const emits = defineEmits<{
  (e: 'update:durationMin', duration: number): void
  (e: 'update:durationMax', duration: number): void
}>()

emits('update:durationMax', 8)

function convertMinutesToLocal(duration: number) {
  return Math.round(duration) / 60
}

function convertLocalToMinutes(duration: number) {
  return Math.max(1, Math.round(duration * 60))
}

const localDurationMin = computed({
  get: () => convertMinutesToLocal(props.durationMin),
  set: (duration: number) => {
    emits('update:durationMin', convertLocalToMinutes(duration))
  },
})

const localDurationMax = computed({
  get: () => convertMinutesToLocal(props.durationMax),
  set: (duration: number) => {
    emits('update:durationMax', convertLocalToMinutes(duration))
  },
})
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;

.Duration {
  $width: 100px;

  display: inline-flex;
  flex-wrap: wrap;
  grid-gap: v.$spacing;
  align-items: center;
  width: 100%;

  &__Label {
    flex: 1 1;
    font-weight: 700;
  }

  :deep(.p-inputgroup) {
    width: auto;
  }

  &__Min,
  &__Max {
    :deep(.p-inputtext) {
      width: $width;
      text-align: right;
    }
  }
}
</style>
